<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblCursoUsuarioRepository;

final class TblCursoUsuarioService
{
    private TblCursoUsuarioRepository $TblCursoUsuarioRepository;

    public function __construct(TblCursoUsuarioRepository $TblCursoUsuarioRepository)
    {
        $this->TblCursoUsuarioRepository = $TblCursoUsuarioRepository;
    }

    public function checkAndGet(int $TblCursoUsuarioId): object
    {
        return $this->TblCursoUsuarioRepository->checkAndGet($TblCursoUsuarioId);
    }

    public function getAll(): array
    {
        return $this->TblCursoUsuarioRepository->getAll();
    }

    public function getOne(int $TblCursoUsuarioId): object
    {
        return $this->checkAndGet($TblCursoUsuarioId);
    }

    public function create(array $input): object
    {
        $TblCursoUsuario = json_decode((string) json_encode($input), false);

        return $this->TblCursoUsuarioRepository->create($TblCursoUsuario);
    }

    public function update(array $input, int $TblCursoUsuarioId): object
    {
        $TblCursoUsuario = $this->checkAndGet($TblCursoUsuarioId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblCursoUsuarioRepository->update($TblCursoUsuario, $data);
    }

    public function delete(int $TblCursoUsuarioId): void
    {
        $this->checkAndGet($TblCursoUsuarioId);
        $this->TblCursoUsuarioRepository->delete($TblCursoUsuarioId);
    }
}
